/***************************************************************************
*
* Copyright (c) 1989 -- 2000
* by Helsinki University of Technology, Digital Systems Laboratory,
* a.k.a. Laboratory for Theoretical Computer Science.
* All rights reserved.
*
* This software is provided "as is" without express or implied warranty.
*
* Module:  alloc.h
*
* Part of: PROD's programs araprod, "gphgen", probe, prod, prpp,
*          strong, and t
*
* Author:  Kimmo Varpaaniemi
*
* Current version:
*     $Id$
*
* Description:
*     See alloc.c.
*
* Version history:
*     $Log$
***************************************************************************/

extern FILE *_in;
extern FILE *_out;
extern FILE *_err;

#ifdef abort
#undef abort
#endif
DE0(VOID, Abort)
#define abort() Abort()
DE1(VOID *, Pvoid,
    char *, pointer)
DE0(BOOL, FileNotFoundErrno)
DE1(void, ErrnoOutput,
    FILE *, file)
DE0(void, ResetErr)
DE0(void, SetIO)
DE2(int, ScanLdu,
    char *, buffer,
    unsigned long *, ulPointer)
DE3(BOOL, BruteReadln,
    char **, buffer,
    unsigned *, n,
    FILE *, file)
DE1(VOID *, Etacolla,
    unsigned, size)
DE2(VOID *, YarraColla,
    unsigned, elCount,
    unsigned, elSize)
DE2(VOID *, Retacolla,
    char *, oldPtr,
    unsigned, size)
DE1(void, Deallocate,
    char *, oldPtr)
#define Allocate(n) Etacolla((unsigned) (n))
#define AllocArray(m,n) YarraColla((unsigned) (m), (unsigned) (n))
#define Reallocate(p,n) Retacolla((char *) (p), (unsigned) (n))
#ifdef UNIX
#define Hallocate(n) Allocate(n)
#define HallocArray(m,n) AllocArray(m,n) 
#define Dehallocate(p) Deallocate((char *) (p))
#else
#ifdef HALLOC
DE2(VOID *, HyarraColla,
    unsigned long, elCount,
    unsigned, elSize)
DE1(void, Dehallocate,
    char *, oldPtr)
#define HallocArray(m,n) HyarraColla((unsigned long) (m), (unsigned) (n))
#define Hallocate(n) HallocArray(n, 1)
#else
#define Hallocate(n) Allocate(n)
#define HallocArray(m,n) AllocArray(m,n) 
#define Dehallocate(p) Deallocate((char *) (p))
#endif
#endif

#define StrCopy(string) strcpy((char *) Allocate(strlen(string) + 1), string)
DE2(char *, FileName,
    char *, name,
    char *, suffix)

#ifndef UNIX
DE0(void, ClockOn)
DE3(void, StoreCmd,
    int, argc,
    char *, cmdName,
    char **, argv)
#endif

#ifdef exit
#undef exit
#endif
DE1(void, Exit,
    int, status)
#define exit(x) Exit(x)

DE0(int, O_n_e)
DE1(int, Z_e_r_o,
    int, n)
