/***************************************************************************
*
* Copyright (c) 1989 -- 2000
* by Helsinki University of Technology, Digital Systems Laboratory,
* a.k.a. Laboratory for Theoretical Computer Science.
* All rights reserved.
*
* This software is provided "as is" without express or implied warranty.
*
* Module:  encode.h
*
* Part of: PROD's programs araprod, "gphgen", probe, and prpp
*
* Authors: Marko Rauhamaa and Kimmo Varpaaniemi
*
* Current version:
*     $Id$
*
* Description:
*     See encode.c.
*
* Version history:
*     $Log$
***************************************************************************/

extern unsigned _ingNofClasses;
#define IngGNofClasses() _ingNofClasses
extern unsigned _ingNofTransitions;
#define IngGNofTransitions() _ingNofTransitions
extern unsigned *_ingProfile;
#define IngGProfile(transition) (_ingProfile[transition])
#define IngIProfile(transition,value) (_ingProfile[transition] = (value))
extern unsigned *_ingFdProfile;
#define IngGFdProfile(transition) (_ingFdProfile[transition])
#define IngIFdProfile(transition,value) (_ingFdProfile[transition] = (value))
extern BALTREE **_ingRange;
#define IngGRange(transition) (_ingRange[transition])
#define IngIRange(transition,tree) (_ingRange[transition] = (tree))
extern BOOL _elimination;
#define Elimination() _elimination
#define SetElimination() (_elimination = TRUE)
#define ClElimination() (_elimination = FALSE)
extern BOOL _depthFirst;
#define Dfs() _depthFirst
#define SetDfs() (_depthFirst = TRUE)
#define ResetDfs() (_depthFirst = FALSE)
extern BOOL _freeExpansion;
#define FreeExpansion() _freeExpansion
#define SetFreeExpansion() (_freeExpansion = TRUE)
#define ResetFreeExpansion() (_freeExpansion = FALSE)
extern unsigned long _onTheFly;
#define OnTheFly() _onTheFly
#define SetOnTheFly() (_onTheFly |= 1L)
#define ClOnTheFly() (_onTheFly = 0L)
#define Reject() (_onTheFly & 2L)
#define SetReject() (_onTheFly |= 2L)
#define StabFail() (_onTheFly & 4L)
#define SetStabFail() (_onTheFly |= 4L)
#define Divergence() (_onTheFly & 8L)
#define SetDivergence() (_onTheFly |= 8L)
#define Infinite() (_onTheFly & (unsigned long) 16)
#define SetInfinite() (_onTheFly |= (unsigned long) 16)
#define ClInfinite() (_onTheFly &= ~((unsigned long) 16))
#define DivNow() (_onTheFly & (unsigned long) 32)
#define SetDivNow() (_onTheFly |= (unsigned long) 32)
#define ClDivNow() (_onTheFly &= ~((unsigned long) 32))
#define InfNow() (_onTheFly & (unsigned long) 64)
#define SetInfNow() (_onTheFly |= (unsigned long) 64)
#define ClInfNow() (_onTheFly &= ~((unsigned long) 64))
#define Buchi() (_onTheFly & (unsigned long) 128)
#define SetBuchi() (_onTheFly |= (unsigned long) 128)
#define ClBuchi() (_onTheFly &= ~((unsigned long) 128))
extern DOMAIN **_x_;
extern unsigned long *_z_;
extern BOOL _pep;
#define Pep() _pep
#define SetPep() (_pep = TRUE)
#define ResetPep() (_pep = FALSE)
extern FILE *_pepFile;
#define PepFile() _pepFile
#define SetPepFile(file) (_pepFile = (file))
extern BOOL _ara;
#define Ara() _ara
#define SetAra() (_ara = TRUE)
#define ResetAra() (_ara = FALSE)
extern FILE *_araFile;
#define AraFile() _araFile
#define SetAraFile(file) (_araFile = (file))
extern FILE *_araArcFile;
#define AraArcFile() _araArcFile
#define AraSetArcFile(file) (_araArcFile = (file))
extern char **_araTraNames;
#define AraTraNames(i) (_araTraNames[i])
extern char ***_araVarNames;
#define AraVarNames(i,j) (_araVarNames[i][j])
extern unsigned **_araIndices;
#define AraIndices(i,j) (_araIndices[i][j])
extern unsigned _araSymCount;
#define AraSymCount() _araSymCount
extern char **_araSymNames;
#define AraSymNames(i) (_araSymNames[i])
extern char **_araPriNames;
#define AraPriNames(i) (_araPriNames[i])
extern BALTREE *_araTree;
#define AraTree() _araTree
#define SetAraTree() (_araTree = BalTrCreate(&drefBalTools))
extern char **_plaNames;
#define PlaNames(i) (_plaNames[i])
extern PATH *_path[4];
extern BALTREE *_nodeTree;
extern STATE *_state;
extern STATE *_folState;
extern STATE *_evalState;
extern BOOL _new;
extern unsigned long _back;
#define thePath (_path[0])
#define the2Path (_path[1])
#define the3Path (_path[2])
#define nowPath (_path[3])
#define theNodeTree _nodeTree
#define theState _state
#define theFolState _folState
#define theEvalState _evalState
#define theNew _new
#define theBack _back
extern unsigned _engBfSize;
#define EngBufSize() _engBfSize
#define EngABufSize() (&_engBfSize)
#define	EngSBufSize(size) (_engBfSize = (size))
extern DATATYPE *_engBuffer;
#define EngBuffer() _engBuffer
#define EngABuffer() (&_engBuffer)
#define	EngSBuffer(buffer) (_engBuffer = (buffer))

extern BOOL _dots;
extern int _inner;
extern int _outer;
#define theDots _dots
#define theInner _inner
#define theOuter _outer

extern unsigned _monPlInd;
#define MonPlInd() _monPlInd

#define NUMERIC 16
#define SYMBOLIC 256

#define Encode(x) \
( \
    ((x) < (DOMAIN) NUMERIC) ? \
        (x) \
    : \
        ( \
            ((x) > (((DOMAIN) MAXDOMAIN) - (DOMAIN) SYMBOLIC)) ? \
                (((DOMAIN) MAXDOMAIN) - ((x) - (DOMAIN) NUMERIC)) \
            : \
                ((x) + (DOMAIN) SYMBOLIC) \
        ) \
)

#define Decode(x) \
( \
    ((x) < (DOMAIN) NUMERIC) ? \
        (x) \
    : \
        ( \
            ((x) < (((DOMAIN) NUMERIC) + (DOMAIN) SYMBOLIC)) ? \
                (((DOMAIN) MAXDOMAIN) - ((x) - (DOMAIN) NUMERIC)) \
            : \
                ((x) - (DOMAIN) SYMBOLIC) \
        ) \
)

#define VALBITS (BITSPERBYTE - 1)
#define VALSIZE (1 << VALBITS)
#define VALMASK (VALSIZE - 1)
#define SEPMK ((DATATYPE) (VALSIZE + 1))
#define CNTMK ((DATATYPE) (VALSIZE + 2))
#define ARIMK ((DATATYPE) (VALSIZE + 3))
#define SPECIALMIN ((DATATYPE) (VALSIZE + 4))

#define IncLen(_val, _len) \
do \
    {  \
	  if ((_val) < VALSIZE) \
	      (_len)++; \
	  else \
	      for ((_len)++; (_val); (_val) >>= VALBITS) \
	          (_len)++; \
    } while (0)

#define PutValue(_val, _p) \
do \
    {  \
        if ((_val) < VALSIZE) \
	   *(_p)++ = (DATATYPE) ((_val) + 1); \
	else \
	   { \
	       register unsigned _o_; \
 \
	      for (_o_ = 0; (_val); (_val) >>= VALBITS) \
	          (_p)[++_o_] = (DATATYPE) (((_val) & VALMASK) + 1); \
	      *(_p) = (SPECIALMIN - 2) + (DATATYPE) _o_; \
	      (_p) += _o_ + 1; \
	   } \
    } while (0)

#define GetValue(_ty, _val, _p) \
do \
    {  \
	   if (*(_p) <= (DATATYPE) VALSIZE) \
	       (_val) = (_ty) (*(_p)++ - 1); \
	   else \
	       { \
	           register unsigned _o_; \
 \
		   _o_ = *(_p) - (SPECIALMIN - 2); \
		   for ((_val) = (_ty) ((_p)[_o_--] - 1); _o_; \
			(_val) |= (_ty) ((_p)[_o_--] - 1)) \
		     (_val) <<= VALBITS; \
		     (_p) += *(_p) - (SPECIALMIN - 3); \
	       } \
    } while (0)

#define SkipValue(_p) \
((*(_p) <= (DATATYPE) VALSIZE) ? ((_p)++) : ((_p) += *(_p) - (SPECIALMIN - 3)))

#define SepCode(_p) (*(_p)++ = SEPMK)
#define SepAt(_p) (*(_p) == SEPMK)
#define SepPass(_p) ((_p)++)
#define CntCode(_p) (*(_p)++ = CNTMK)
#define CntAt(_p) (*(_p) == CNTMK)
#define CntPass(_p) ((_p)++)
#define AriCode(_p) (*(_p)++ = ARIMK)
#define AriAt(_p) (*(_p) == ARIMK)
#define AriPass(_p) ((_p)++)

DE2(void, BaseInit,
    BINARYFILE, file,
    BOOL, readRanges)
DE2(void, BaseLTSInit,
    unsigned, nHiPlc,
    unsigned, nHiTr)
DE1(STATE *, InitialState,
    BINARYFILE, file)
DE5(BOOL, InRange,
    unsigned, t,
    unsigned, n,
    DOMAIN *, a,
    DATATYPE **, buffer,
    unsigned *, size)
DE4(void, TravRange,
    unsigned, t,
    unsigned, n,
    DOMAIN *, a,
    VOF, f)
DE4(unsigned, TupEncode,
    unsigned, place,
    TUPLE *, tuple,
    DATATYPE **, buffer,
    unsigned *, size)
DE3(void, TupDecode,
    unsigned *, place,
    DATATYPE *, buffer,
    TUPLE *, tuple)
DE3(void, PlKeyOut,
    DATATYPE *, key,
    FILE *, file,
    BOOL, pepInTurn)
#ifdef DEBUG
DE2(void, PlKeySp,
    DATATYPE *, key,
    char *, buf)
#endif
DE3(unsigned, StaEncode,
    STATE *, state,
    DATATYPE **, buffer,
    unsigned *, size)
DE2(void, StaDecode,
    DATATYPE *, buffer,
    STATE *, state)
#ifdef WEIRD
DE6(unsigned, InsEncode,
    unsigned, trIndex,
    unsigned, priority,
    DOMAIN *, instance,
    DATATYPE **, buffer,
    unsigned *, size,
    unsigned, offset)
DE3(DOMAIN *, InsDecode,
    unsigned *, pTrIndex,
    unsigned *, priority,
    DATATYPE **, argPointer)
#else
DE5(unsigned, InsEncode,
    unsigned, trIndex,
    unsigned, priority,
    DOMAIN *, instance,
    DATATYPE **, buffer,
    unsigned *, size)
DE3(DOMAIN *, InsDecode,
    unsigned *, pTrIndex,
    unsigned *, priority,
    DATATYPE *, buffer)
#endif
DE2(int, BTupComp,
    DATATYPE *, buffer1,
    DATATYPE *, buffer2)
DE2(int, InsComp,
    DATATYPE *, buffer1,
    DATATYPE *, buffer2)
DE2(BOOL, FdEqual,
    DATATYPE *, buffer1,
    DATATYPE *, buffer2)
DE0(void, DotOutput)
DE1(void, AraNames,
    BINARYFILE, datFile)
DE1(void, DelAraNames,
    BOOL, delSymNames)
DE1(void, RdPlaNames,
    BINARYFILE, datFile)
DE0(void, DelPlaNames)
DE4(void, InsOutput,
    unsigned long, number,
    DATATYPE *, key,
    FILE *, file,
    BOOL, pepInTurn)
#ifdef DEBUG
DE2(void, InsSp,
    DATATYPE *, key,
    char *, buf)
#endif
