/***************************************************************************
*
* Copyright (c) 1989 -- 2000
* by Helsinki University of Technology, Digital Systems Laboratory,
* a.k.a. Laboratory for Theoretical Computer Science.
* All rights reserved.
*
* This software is provided "as is" without express or implied warranty.
*
* Module:  inst.h
*
* Part of: PROD's program "gphgen"
*
* Authors: Marko Rauhamaa and Kimmo Varpaaniemi
*
* Current version:
*     $Id$
*
* Description:
*     See inst.c.
*
* Version history:
*     $Log$
***************************************************************************/

/* The PEER type is needed for saving an enabled transition instance
 * for a later precedence check. It is not needed if there is only the
 * default independent precedence class 0. The element of PEER are called
 * peers. */
typedef struct
{
    unsigned flag;
    unsigned trIndex;
    DOMAIN *instance;
    DATATYPE *buffer;
} PEER;

#define PeeOn(peer) ((peer)->flag & 1)
#define PeeSet(peer) ((peer)->flag |= 1)
#define PeeVisible(peer) ((peer)->flag & 2)
#define PeeSVisible(peer) ((peer)->flag |= 2)
#define PeeGTrIndex(peer) ((peer)->trIndex)
#define PeeGInstance(peer) ((peer)->instance)
#define PeeGBuffer(peer) ((peer)->buffer)
#define PeeAlloc() (PEER *) Allocate(sizeof(PEER))
extern TOOLS peeTools;
#ifdef WEIRD
extern BOOL _c_o_m_p_a_c_t_;
#endif

DE0(void, _Followers)
DE0(void, _CompInst)
DE0(void, _CompPrec)
DE0(BOOL, _BuchiOK)
DE4(PEER *, PeeCons,
    unsigned, trIndex,
    DOMAIN *, instance,
    DATATYPE *, buffer,
    unsigned, visible)
DE1(PEER *, PeeCopy,
    PEER *, peer)
DE1(void, PeeDiscard,
    PEER *, peer)
#ifdef DEBUG
DE2(void, PeeDump,
    PEER *, peer,
    unsigned, depth)
#endif
DE0(void, IllTrace)
DE1(void, IllDivTrace,
    BOOL, isExpanding)
DE1(void, IllInfTrace,
    BOOL, isExpanding)
DE0(void, DoOnTheFly)
DE0(void, DoInfinite)
DE0(void, DoInner)
DE0(void, DoBuchi)
DE1(void, AraStep,
    unsigned, visible)
