/***************************************************************************
*
* Copyright (c) 1989 -- 2000
* by Helsinki University of Technology, Digital Systems Laboratory,
* a.k.a. Laboratory for Theoretical Computer Science.
* All rights reserved.
*
* This software is provided "as is" without express or implied warranty.
*
* Module:  prod.h
*
* Part of: PROD's programs araprod, "gphgen", probe, prod, prpp,
*          strong, and t
*
* Authors: Marko Rauhamaa and Kimmo Varpaaniemi
*
* Current version:
*     $Id$
*
* Description:
*     This module contains macros that are needed everywhere in PROD.
*     There is no need to include prod.h in a net description. A user
*     of PROD does not have to know anything about the below macros.
*     (Manuals or reports claiming the opposite are out of date.)
*     The used definition of DOMAIN guarantees that no information
*     is lost in conversions from other integer types to the DOMAIN
*     type. (We do not use the plain long type because it would be more
*     sensitive to overflows in positive arithmetic. Nobody really needs
*     negative tuple fields.)
*
* Version history:
*     $Log$
***************************************************************************/

#ifndef NULL
#define NULL 0x0
#endif
#ifndef DOMAIN
#define DOMAIN unsigned long
#define UDOMAIN unsigned long
#define MINDOMAIN 0L
#define MAXDOMAIN (~MINDOMAIN)
#define DOMFORMAT "%lu"
#define UDOMFORMAT "%lu"
#define DOMXFORMAT "0x%lx"
#endif
#ifndef BITSPERBYTE
#define BITSPERBYTE 8
#endif
#ifndef MAX32
#define MAX32 0xffffffff
#endif
#ifndef UNS32
#if (MAX32 == ~0L)
#define UNS32 unsigned long
#else
#define UNS32 unsigned
#endif
#endif
#ifndef UCHAR
#define UCHAR unsigned char
#endif
#ifndef DATATYPE
#define DATATYPE unsigned char
#endif
#ifndef BOOL
#define BOOL int
#endif
#ifndef FALSE
#define FALSE 0
#define TRUE 1
#endif
#ifndef VOID
#define VOID void
#endif
#ifndef DIRCHAR
#ifdef UNIX
#define DIRCHAR '/'
#else
#define DIRCHAR '\\'
#endif
#endif
