/***************************************************************************
*
* Copyright (c) 1989 -- 2000
* by Helsinki University of Technology, Digital Systems Laboratory,
* a.k.a. Laboratory for Theoretical Computer Science.
* All rights reserved.
*
* This software is provided "as is" without express or implied warranty.
*
* Module:  ptrbl.h
*
* Part of: PROD's programs araprod, "gphgen", probe, and strong
*
* Author:  Kimmo Varpaaniemi
*
* Current version:
*     $Id$
*
* Description:
*     See ptrbl.c.
*
* Version history:
*     $Log$
***************************************************************************/

/* An element of PTRBL is a segmented pointer table. */
typedef struct PTRBL 
{
    VOID **root;            /* the actual table */
    unsigned long ptrCount; /* the number of leaf pointers */
    unsigned bits;          /* this is determined by ptrCount and
                             * affects the number of segmentation levels */
    TOOLS *tools;           /* a collection of routines needed in copying,
                             * deleting or displaying of the stuff pointed
                             * by the leaf pointers */
} PTRBL;

#define PtrBlAlloc() ((PTRBL *) Allocate(sizeof(PTRBL)))
#define PtrBlGCount(ptrbl) ((ptrbl)->ptrCount)

DE2(PTRBL *, PtrBlCreate,
    unsigned long, ptrCount,
    TOOLS *, tools)
DE2(PTRBL *, PtrBlCopy,
    PTRBL *, ptrbl,
    BOOL, elCopy)
DE2(void, PtrBlDestroy,
    PTRBL *, ptrbl,
    BOOL, elDiscard)
DE2(void, PtrBlDump,
    PTRBL *, ptrbl,
    unsigned, depth)
DE3(void, PtrBlPut,
    PTRBL *, ptrbl,
    char *, ptr,
    unsigned long, number)
DE2(VOID *, PtrBlGet,
    PTRBL *, ptrbl,
    unsigned long, number)
DE2(VOID **, PtrBlApply,
    PTRBL *, ptrbl,
    FOOL, f)
DE2(VOID **, PtrBlBackApply,
    PTRBL *, ptrbl,
    FOOL, f)
DE2(VOID **, PtrBlAddrApply,
    PTRBL *, ptrbl,
    FOOL, f)
DE2(VOID **, PtrBlBkdrApply,
    PTRBL *, ptrbl,
    FOOL, f)
