/***************************************************************************
*
* Copyright (c) 1989 -- 2000
* by Helsinki University of Technology, Digital Systems Laboratory,
* a.k.a. Laboratory for Theoretical Computer Science.
* All rights reserved.
*
* This software is provided "as is" without express or implied warranty.
*
* Module:  ptsymm.h
*
* Part of: PROD's programs araprod and "gphgen"
*
* Author:  Kimmo Varpaaniemi
*
* Current version:
*     $Id$
*
* Description:
*     See ptsymm.c.
*
* Version history:
*     $Log$
***************************************************************************/

extern LIST *_plcSyGenerators;
#define PlcSymmGenerators() _plcSyGenerators
extern BALTREE *_plcSymmetries;
#define PlcSymmetries() _plcSymmetries
extern BOOL _plcIMkSymm;
#define PlcIMkSymm() _plcIMkSymm
#define SetPlcIMkSymm() (_plcIMkSymm = TRUE)
#define ResetPlcIMkSymm() (_plcIMkSymm = FALSE)

DE1(void, CompSymm,
    BOOL, delIdMap)

typedef struct PP
{
    BALTREE *domain;
    BALTREE *range;
} PP;

#define PpAlloc() ((PP *) Allocate(sizeof(PP)))
#define PpGDomain(pp) ((pp)->domain)
#define PpADomain(pp) (&((pp)->domain))
#define PpSDomain(pp,_domain) ((pp)->domain = (_domain))
#define PpGRange(pp) ((pp)->range)
#define PpARange(pp) (&((pp)->range))
#define PpSRange(pp,_range) ((pp)->range = (_range))

typedef struct CNSTR
{
    LIST *pPairs;
    LIST *tPairs;
} CNSTR;

#define CnstrAlloc() ((CNSTR *) Allocate(sizeof(CNSTR)))
#define CnstrGPPairs(cnstr) ((cnstr)->pPairs)
#define CnstrAPPairs(cnstr) (&((cnstr)->pPairs))
#define CnstrSPPairs(cnstr,_pPairs) ((cnstr)->pPairs = (_pPairs))
#define CnstrGTPairs(cnstr) ((cnstr)->tPairs)
#define CnstrATPairs(cnstr) (&((cnstr)->tPairs))
#define CnstrSTPairs(cnstr,_tPairs) ((cnstr)->tPairs = (_tPairs))

extern BALTREE *ptrTree;
extern BALTREE *ptrTree2;
extern unsigned long multipl;
extern TOOLS ptrTools;
extern BALTOOLS ptrBalTools;
extern BALTOOLS clpBalTools;
extern BALTOOLS nrtBalTools;
extern TOOLS ppTools;
extern TOOLS mrepTools;
extern BALTOOLS mrepBalTools;

#ifdef DEBUG
DE2(void, PtrDump,
    char *, ptr,
    unsigned, depth)
#endif
DE2(int, PtrCompare,
    char *, ptr1,
    char *, ptr2)
DE1(BOOL, PtrCut,
    char *, ptr)
DE1(BOOL, PtrMinus,
    char *, ptr)
DE1(BOOL, PtrAdd,
    char *, ptr)
DE2(BALTREE *, PtrTrCut,
    BALTREE *, ptrTr1,
    BALTREE *, ptrTr2)
DE2(BALTREE *, PtrTrMinus,
    BALTREE *, ptrTr1,
    BALTREE *, ptrTr2)
DE2(int, PlcDegCompare,
    PLC *, plc1,
    PLC *, plc2)
DE2(int, TrnDegCompare,
    TRN *, trn1,
    TRN *, trn2)
DE1(BOOL, PlcPre,
    PLC *, plc)
DE1(BOOL, PlcPost,
    PLC *, plc)
DE1(BOOL, TrnPre,
    TRN *, trn)
DE1(BOOL, TrnPost,
    TRN *, trn)
DE2(BALTREE *, PrePlcTr,
    BALTREE *, plcTree,
    unsigned long, i)
DE2(BALTREE *, PostPlcTr,
    BALTREE *, plcTree,
    unsigned long, i)
DE2(BALTREE *, PreTrnTr,
    BALTREE *, trnTree,
    unsigned long, i)
DE2(BALTREE *, PostTrnTr,
    BALTREE *, trnTree,
    unsigned long, i)
DE1(BOOL, MltPlcPre,
    PLC *, plc)
DE1(BOOL, MltPlcPost,
    PLC *, plc)
DE1(BOOL, MltTrnPre,
    TRN *, trn)
DE1(BOOL, MltTrnPost,
    TRN *, trn)
DE2(BALTREE *, MltPrePlcTr,
    BALTREE *, plcTree,
    BALTREE *, lngTree)
DE2(BALTREE *, MltPostPlcTr,
    BALTREE *, plcTree,
    BALTREE *, lngTree)
DE2(BALTREE *, MltPreTrnTr,
    BALTREE *, trnTree,
    BALTREE *, lngTree)
DE2(BALTREE *, MltPostTrnTr,
    BALTREE *, trnTree,
    BALTREE *, lngTree)
DE2(PP *, PpCons,
    BALTREE *, domain,
    BALTREE *, range)
DE1(PP *, PpCopy,
    PP *, pp)
DE1(void, PpDiscard,
    PP *, pp)
#ifdef DEBUG
DE2(void, PpDump,
    PP *, pp,
    unsigned, depth)
#endif
DE2(CNSTR *, CnstrCons,
    LIST *, pPairs,
    LIST *, tPairs)
DE1(CNSTR *, CnstrCopy,
    CNSTR *, cnstr)
DE1(void, CnstrDiscard,
    CNSTR *, cnstr)
#ifdef DEBUG
DE2(void, CnstrDump,
    CNSTR *, cnstr,
    unsigned, depth)
DE1(void, CnstrChk,
    CNSTR *, cnstr)
#endif
DE1(PTRBL *, MrepCopy,
    PTRBL *, mrep)
DE1(void, MrepDiscard,
    PTRBL *, mrep)
DE2(int, MrepCompare,
    PTRBL *, mrep1,
    PTRBL *, mrep2)
DE1(BOOL, RefiPrePost,
    unsigned long *, weight)
DE1(BOOL, RefiPostPre,
    unsigned long *, weight)
DE0(BOOL, Refine)
DE0(void, ExhaustRefine)
DE1(BOOL, PartialSymm,
    PTRBL *, symm)
DE1(BOOL, FirstExpand,
    PTRBL *, symm)
DE1(BOOL, SymmExpand,
    PTRBL *, symm)
DE1(BOOL, SymmRealize,
    PTRBL *, symm)
DE1(BOOL, DeSyP,
    PLC *, plc)
DE1(void, DefineSym,
    CNSTR *, cnstr)
DE1(BOOL, PlcGroup,
    PLC *, plc)
DE1(BOOL, TrnGroup,
    TRN *, trn)
DE1(BOOL, PlcNorm,
    PLC *, plc)
DE1(BOOL, SymmOut,
    PTRBL *, symm)
